// gcc -o autoclick autoclick.c -lX11

#include <stdio.h>
#include <string.h>
#include <X11/Xlib.h>


// substitute your screen size here
#define SCREEN_SIZE_X 1023
#define SCREEN_SIZE_Y 599


#define DL_BAR_X 1004
#define DL_BAR_Y 575

#define USLEEP 1


void
click_mouse (Display *display, int button)
{
  XEvent event;
  memset (&event, 0, sizeof (event));
  event.xbutton.button = button;
  event.xbutton.same_screen = True;
  event.xbutton.subwindow = DefaultRootWindow (display);
  while (event.xbutton.subwindow)
    {
      event.xbutton.window = event.xbutton.subwindow;
      XQueryPointer (display, event.xbutton.window,
		     &event.xbutton.root, &event.xbutton.subwindow,
		     &event.xbutton.x_root, &event.xbutton.y_root,
		     &event.xbutton.x, &event.xbutton.y,
		     &event.xbutton.state);
    }

  event.type = ButtonPress;
  if (XSendEvent (display, PointerWindow, True, ButtonPressMask, &event) == 0)
    fprintf (stderr, "Error to send the event!\n");
  XFlush (display);
  usleep (USLEEP);

  event.type = ButtonRelease;
  if (XSendEvent (display, PointerWindow, True, ButtonReleaseMask, &event) == 0)
    fprintf (stderr, "Error to send the event!\n");
  XFlush (display);
  usleep (USLEEP);
}


void
move_mouse (Display *display, int x, int y)
{
  XWarpPointer (display, None, None, 0,0,0,0, SCREEN_SIZE_X*-1, SCREEN_SIZE_Y*-1);
  XWarpPointer (display, None, None, 0,0,1023,599, x, y);

  XFlush (display);
  usleep (USLEEP);
}


void
get_coords (Display *display, int *x, int *y)
{
  XEvent event;
  XQueryPointer (display, DefaultRootWindow (display),
                 &event.xbutton.root, &event.xbutton.window,
                 &event.xbutton.x_root, &event.xbutton.y_root,
                 &event.xbutton.x, &event.xbutton.y,
                 &event.xbutton.state);

  *x = event.xbutton.x;
  *y = event.xbutton.y;
}


int
main (int argc, char *argv[])
{ 
  int x = 0;
  int y = 0;

  Display *display = XOpenDisplay (NULL);
  if (display == NULL)
    {
      fprintf (stderr, "Cannot open display!\n");
      return -1;
    }
  
  get_coords (display, &x, &y);

  move_mouse (display, DL_BAR_X, DL_BAR_Y);

  click_mouse (display, Button1);

  move_mouse (display, x, y);

  XCloseDisplay (display);
  return 0;
}
